//======================================================================
//  flaa; source include
//    Author: Dave Freese, W1HKJ <w1hkj@w1hkj.com>
//
//  based on the program RTTY Compare by
//    Alex Shovkoplyas, VE3NEA ve3nea@dxatlas.com
//  Original written in Pascal and distributed only for Windows OS
//
//  This program is distributed under the GPL license
//======================================================================

#ifndef _FLAA_H_
#define _FLAA_H_

#include <stdlib.h>
#include <fstream>
#include <iostream>
#include <sstream>
#include <math.h>
#include <string>
#include <vector>

#include <FL/Fl_Double_Window.H>
#include <FL/fl_show_colormap.H>
#include <FL/Fl_Button.H>

#include "Cartesian.H"
#include "serial.h"

//#define DEBUG 1

using namespace std;

extern Fl_Double_Window *main_window;
extern Fl_Double_Window *configure_dialog;

extern string flaa_home_dir;

extern Fl_Color color_select(Fl_Button *b);

extern void cb_exit();
extern void cb_ser_device();
extern void cb_configure();
extern void cb_run();
extern void cb_connect();
extern void cb_min_freq();
extern void cb_max_freq();
extern void cb_nr_pts();
extern void cb_Z0();

extern void vf_select();

extern double swr_on_80;
extern void update_swr_80(void *);
extern double swr_on_60;
extern void update_swr_60(void *);
extern double swr_on_40;
extern void update_swr_40(void *);
extern double swr_on_30;
extern void update_swr_30(void *);
extern double swr_on_20;
extern void update_swr_20(void *);
extern double swr_on_15;
extern void update_swr_15(void *);
extern double swr_on_10;
extern void update_swr_10(void *);
extern double swr_on_6;
extern void update_swr_6(void *);
extern double swr_on_2;
extern void update_swr_2(void *);
extern double swr_on_440;
extern void update_swr_440(void *);

extern void swr_80();
extern void swr_60();
extern void swr_40();
extern void swr_30();
extern void swr_20();
extern void swr_15();
extern void swr_10();
extern void swr_6();
extern void swr_2();
extern void swr_440();
extern void swr_stop_all();
extern void clear_swrs();

extern void run_80();
extern void run_60();
extern void run_40();
extern void run_30();
extern void run_20();
extern void run_15();
extern void run_10();
extern void run_6();
extern void run_2();
extern void run_220();
extern void run_440();
extern void run_other();

extern void rf_on_off(int onoff);

extern void compute_length();
extern void compute_velocity();

extern void  export_data();
extern void import_data();

extern void update_cable_values(void *);

extern string hexstr(string);
extern void  plot_data(void *);

extern void xaxis_config(
	Ca_X_Axis *axis,
	int lblsize,
	int scaletype,
	double minval, double maxval,
	double major_step, double minor_step,
	string format,
	Fl_Color minor_color, Fl_Color major_color, Fl_Color lbl_color,
	int grid_visibility,
	Fl_Color axis_color,
	int align
	);

extern void yaxis_config(
	Ca_Y_Axis *axis,
	int lblsize,
	int scaletype,
	double minval, double maxval,
	double major_step, double minor_step,
	string format,
	Fl_Color minor_color, Fl_Color major_color, Fl_Color lbl_color,
	int grid_visibility,
	Fl_Color axis_color,
	int align
	);

extern void config_axis();

struct FRX {
	float f; float r; float x;
	FRX() { f = r = x = 0; }
	FRX(float a, float b, float c) { f = a; r = b; x = c; }
};

extern vector<FRX> testdata;
extern Cserial aa_ser_port;

#define BUFFSIZE  8192
extern char serbuff[];

#endif
