// ----------------------------------------------------------------------------
// Copyright (C) 2014
//              David Freese, W1HKJ
//
// This file is part of flrig.
//
// flrig is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// flrig is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ----------------------------------------------------------------------------

#ifndef _status_H
#define _status_H

#include <string>
#include <FL/Fl.H>
#include <FL/Enumerations.H>
#include <FL/fl_show_colormap.H>

#include "flaa.h"

using namespace std;

struct status {
	int		mainX;
	int		mainY;
	int		mainW;
	int		mainH;
	string	serial_port;
	int		baudrate;

	int		units;
	double	system_z;
	double	fmin;
	double	fmax;
	int		npts;

	string	port_ids;

	double	freq_80;
	double	freq_60;
	double	freq_40;
	double	freq_30;
	double	freq_20;
	double	freq_15;
	double	freq_10;
	double	freq_6;
	double	freq_2;
	double	freq_220;
	double	freq_440;
	double	freq_other;

	double	carrier_freq;
	double	freq_corr;

	double	cable_freq;
	double	velocity_factor;
	double	cable_length;

	double	wave;

	int		swr_point;
	int		swr_color;

	int		r_point;
	int		r_color;

	int		x_point;
	int		x_color;

// not saved between sessions
	bool	swr_80_on;
	bool	swr_60_on;
	bool	swr_40_on;
	bool	swr_30_on;
	bool	swr_20_on;
	bool	swr_15_on;
	bool	swr_10_on;
	bool	swr_6_on;
	bool	swr_2_on;
	bool	swr_220_on;
	bool	swr_440_on;
	bool	swr_other_on;

	void saveLastState();
	void loadLastState();
	void testCommPorts();
};

extern status flaa_status;

#endif
